/****************************************************************************
*
*	Agente Movel que busca as variaveis do vetor variaveis em cada host
*	do vetor itinerario enviando os resultados com uma dada frequencia.
*
*   Em caso de falha ele vai para o proximo no.
*
*****************************************************************************/


import java.util.*;
import java.lang.reflect.*;
import java.io.Serializable;

public class Agente02 extends AgMovel
	implements Serializable {

//------------------------------------------------------------------------

private Vector[] result;
private int i = 0;
private int f = 0;
private int frequencia = 0;
private boolean notHome = true;
private boolean jamandei = false;

//------------------------------------------------------------------------

public Agente02(Vector it, Vector var, String h, int por, int freq, String tar, String t) {

/*	it 	= 	itinerario
	var =	variaveis
	h 	= 	home
	por = 	porta
	freq = 	frequencia com que sera enviado os resultados	
*/

	super(it, var, h, por, tar);
	frequencia = freq;
	result = new Vector[1];
	result[0] = new Vector(1);

}
																		
//------------------------------------------------------------------------

public void run() {
	
	// Buscar variaveis
	
	if(!(i == 0)) {
		f++;
		jamandei = false;						
		// Acrescentar o codigo para buscar a variavel
		int v = 0;
		while(v<variaveis.size()){
			result[0].add(Agente_Tradutor.consulta((String)
						itinerario.get(i- 1), (String)variaveis.get(v)));
			v++;
		}
	}
	
	// Enviar resultado
	
	if(f == frequencia){
		jamandei = true;
		f = 0;
		
		//Codigo para mandar os resultados
		Mensagem r = new Mensagem("teste",home,porta,
									(String)itinerario.get(i-1), id, result,tarefa); 
		r.enviar();
		result[0] = null;
		result[0] = new Vector(1);
	}	
	
	// Migrar para o proximo no
	
		while(i<it_tam) {
			i++;
			
			try{migrar((String)itinerario.get(i-1), porta);}
			catch(MigrarException e){
				int y = 0;
				int aux = variaveis.size();
				while(y<aux){
					result[0].add("Falhou");
					y++;
				}	
			}
		}	

	//Codigo para mandar os resultados no final do itinerario
	
	if(!jamandei) {
		Mensagem u = new Mensagem("teste",home,porta,
							(String)itinerario.get(i-1), id, result, tarefa); 
		u.enviar();
	}
	acabei();
}

//------------------------------------------------------------------------

}
