/****************************************************************************
*
*	Agente Movel que busca as variaveis do vetor variaveis em cada host
*	do vetor itinerario enviando os resultados com uma dada frequencia.
*	Alem disto, ele armazena o tempo gasto para realizar cada pedido.
*
*   Em caso de falha ele vai para o proximo no.
*
*****************************************************************************/


import java.util.*;
import java.lang.reflect.*;
import java.io.Serializable;

public class Agente02_1 extends AgMovel
	implements Serializable {

//------------------------------------------------------------------------

private Vector[] result;
private int i = 0;
private int f = 0;
private long t1,t2= 0;
//private String tarefa = null;
private int frequencia = 0;
private boolean notHome = true;
private boolean jamandei = false;

//------------------------------------------------------------------------

public Agente02_1(Vector it, Vector var, String h, int por, int freq, String tar, String t) {

/*	it 	= 	itinerario
	var =	variaveis
	h 	= 	home
	por = 	porta
	freq = 	frequencia com que sera enviado os resultados	
*/

	super(it, var, h, por, tar);
	//System.out.println(id+": Passei aqui 02::   " + tar);
	frequencia = freq;
	result = new Vector[2];
	result[0] = new Vector(1);
	result[1] = new Vector(1);

}
																		
//------------------------------------------------------------------------

public void run() {
	
	// Buscar variaveis
	if(!(i == 0)) {
		f++;
		jamandei = false;
		
		
		// Acrescentar o codigo para buscar a variavel
		int v = 0;
		while(v<variaveis.size()){
			t1 = System.currentTimeMillis();
			result[0].add(Agente_Tradutor.consulta((String)
						itinerario.get(i-1), (String)variaveis.get(v)));
			t2 = System.currentTimeMillis();
			long tf = t2-t1;
			result[1].add(new Integer((int)tf));
			v++;
		}
	}
	
	// Enviar resultado
	
	if(f == frequencia){
		jamandei = true;
		f = 0;
	
		//Codigo para mandar os resultados
	
		int y = 0;
		Mensagem r = new Mensagem("teste",home,porta,
									(String)itinerario.get(i-1), id, result, tarefa); 
		r.enviar();
		result[0] = null;
		result[1] = null;
		result[0] = new Vector(1);
		result[1] = new Vector(1);
	}	
	
	// Migrar para o proximo no
	
		while(i < it_tam){
			i++;
			
			try{migrar((String)itinerario.get(i-1), porta);}
			catch(MigrarException e){
				int y = 0;
				int aux = variaveis.size();
				while(y<aux){
					result[0].add("Falhou");
					result[1].add("Falhou");
					y++;
				}	
				jamandei = false;
			}
		}	

	//Codigo para mandar os resultados no final do itinerario
	
	if(!jamandei){
		Mensagem u = new Mensagem("teste",home,porta,
							(String)itinerario.get(i-1), id, result, tarefa); 
		u.enviar();
	}
	acabei();
	
}

//------------------------------------------------------------------------

}
