/*
 * Principal.java
 *
 */

/**
 *
 * @author  Velloso
 */

import java.util.*;
import javax.swing.*;
import javax.swing.filechooser.*;

public class Principal extends javax.swing.JFrame {

    /** Creates new form Principal */
    public Principal() {
                
        initComponents();
    }

   
    private void initComponents() {//GEN-BEGIN:initComponents
        jMenuBar1 = new javax.swing.JMenuBar();
        Tarefa = new javax.swing.JMenu();
        Criar = new javax.swing.JMenuItem();
        Editar = new javax.swing.JMenuItem();
        Remover = new javax.swing.JMenuItem();
        Executar = new javax.swing.JMenuItem();
        Cancelar = new javax.swing.JMenuItem();
        Sair = new javax.swing.JMenuItem();
        Visualizar = new javax.swing.JMenu();
        Agentes = new javax.swing.JMenuItem();
        Resultados = new javax.swing.JMenu();
        Numero = new javax.swing.JMenuItem();
        Grafico = new javax.swing.JMenuItem();
        Ajuda = new javax.swing.JMenu();
        arquivos = new javax.swing.JMenuItem();
        criarTarefa = new javax.swing.JMenuItem();
        executarTarefa = new javax.swing.JMenuItem();
        Info = new javax.swing.JMenu();
        Autor = new javax.swing.JMenuItem();
        
        Tarefa.setText("Tarefa");
        Tarefa.setToolTipText("");
        Criar.setText("Criar");
        Criar.setName("Crair");
        Criar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CriarActionPerformed(evt);
            }
        });
        
        Tarefa.add(Criar);
        Editar.setText("Editar");
        Editar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EditarActionPerformed(evt);
            }
        });
        
        Tarefa.add(Editar);
        Remover.setText("Remover");
		Remover.setEnabled(false);
        Remover.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RemoverActionPerformed(evt);
            }
        });
        
        Tarefa.add(Remover);
        Executar.setText("Executar");
        Executar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExecutarActionPerformed(evt);
            }
        });
        
        Tarefa.add(Executar);
        Cancelar.setText("Cancelar");
		Cancelar.setEnabled(false);
        Cancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CancelarActionPerformed(evt);
            }
        });
        
        Tarefa.add(Cancelar);
        Sair.setText("Sair");
        Sair.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SairActionPerformed(evt);
            }
        });
        
        Tarefa.add(Sair);
        jMenuBar1.add(Tarefa);
        Visualizar.setText("Visualizar");
        Agentes.setText("Agentes");
        Agentes.setEnabled(false);
        Visualizar.add(Agentes);
        Resultados.setText("Resutados");
        Numero.setText("Numericamente");
        Numero.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                NumeroActionPerformed(evt);
            }
        });
        
        Resultados.add(Numero);
        Grafico.setText("Graficamente");
        Grafico.setEnabled(false);
        Resultados.add(Grafico);
        Visualizar.add(Resultados);
        jMenuBar1.add(Visualizar);
        Ajuda.setText("Ajuda");
        arquivos.setText("Arquivos importantes");
        arquivos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                arquivosActionPerformed(evt);
            }
        });
        
        Ajuda.add(arquivos);
        criarTarefa.setText("Criar tarefa");
        criarTarefa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                criarTarefaActionPerformed(evt);
            }
        });
        
        Ajuda.add(criarTarefa);
        executarTarefa.setText("Executar Tarefa");
        executarTarefa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                executarTarefaActionPerformed(evt);
            }
        });
        
        Ajuda.add(executarTarefa);
        jMenuBar1.add(Ajuda);
        Info.setText("Info");
        Autor.setText("Autor");
        Autor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AutorActionPerformed(evt);
            }
        });
        
        Info.add(Autor);
        jMenuBar1.add(Info);
        
        setTitle("AGUA");
        setName("mainframe");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        setJMenuBar(jMenuBar1);
        pack();
    }//GEN-END:initComponents

    private void AutorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AutorActionPerformed
        
        Arquivo ar =  new Arquivo("info",homedir+"doc","txt");
        Ajuda a = new Ajuda(ar);
        a.setSize(400,350);
        a.show();
                
    }//GEN-LAST:event_AutorActionPerformed

    private void executarTarefaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_executarTarefaActionPerformed
                
        Arquivo ar =  new Arquivo("executarTarefa",homedir+"doc","txt");
        Ajuda a = new Ajuda(ar);
        a.setSize(400,350);
        a.show();
        
    }//GEN-LAST:event_executarTarefaActionPerformed

    private void criarTarefaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_criarTarefaActionPerformed
        Arquivo ar =  new Arquivo("criarTarefa",homedir+"doc","txt");
        Ajuda a = new Ajuda(ar);
        a.setSize(400,350);
        a.show();
        
    }//GEN-LAST:event_criarTarefaActionPerformed

    private void arquivosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_arquivosActionPerformed
       
        Arquivo ar =  new Arquivo("arquivos",homedir+"doc","txt");
        Ajuda a = new Ajuda(ar);
        a.setSize(400,350);
        a.show();
        
    }//GEN-LAST:event_arquivosActionPerformed

    private void SairActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SairActionPerformed
        
        System.exit(0);
        
    }//GEN-LAST:event_SairActionPerformed

    private void CancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CancelarActionPerformed
        
        int returnVal = fc.showOpenDialog(Principal.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
                    String file = fc.getSelectedFile().getName();
                    System.out.println(file);
        }       
        
    }//GEN-LAST:event_CancelarActionPerformed

    private void RemoverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RemoverActionPerformed
     
        int returnVal = fc.showOpenDialog(Principal.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
                    String file = fc.getSelectedFile().getName();
                    System.out.println(file);
        }       
        
        
    }//GEN-LAST:event_RemoverActionPerformed

    private void EditarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EditarActionPerformed
        // Add your handling code here:
       
        int returnVal = fc.showOpenDialog(Principal.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
                    String file = fc.getSelectedFile().getName();
                    int i = file.indexOf('.');
                    String tar = file.substring(0,i);
                    Criar_Tarefa ct = new Criar_Tarefa();
                    ct.setSize(612,490);
                    ct.editar(tar);
                    ct.show();
        }        
    
    }//GEN-LAST:event_EditarActionPerformed

    private void ExecutarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExecutarActionPerformed
        
        
        int returnVal = fc.showOpenDialog(Principal.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
                    String file = fc.getSelectedFile().getName();
                    int i = file.indexOf('.');
                    String tar = file.substring(0,i);
                    co = new Controlador_Tarefas();
                    co.executar_Tarefa(tar);
        }          
        
        
        
    }//GEN-LAST:event_ExecutarActionPerformed

    private void NumeroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NumeroActionPerformed
        
        
        Visualizar v = new Visualizar();
        v.setSize(565,475);
        v.show();
        
        
    }//GEN-LAST:event_NumeroActionPerformed

    private void CriarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CriarActionPerformed
        // Add your handling code here:
        Criar_Tarefa c = new Criar_Tarefa();
        c.setSize(612,490);
        c.show();
    }//GEN-LAST:event_CriarActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        homedir = args[1];
		initServidores();
        if(args[0].equals("i")) {
            Principal p = new Principal();
            p.setSize(500,350);
            p.show();
    
        }
    }

    private static void initServidores() {
        
        Arquivo arq = new Arquivo("maquina",homedir+"etc","cfg");
        Vector config = new Vector(1);
        try{config = arq.le();}
        catch(Exception io) {
            System.out.println("Nao conseguir ler o arqivo de configuracao: " +io);
        }
        home = (String)config.get(0);
        porta = (new Integer((String)config.get(1))).intValue();
    
    	try{new Thread(new Servidor_Mensagens(home,porta)).start();}
	catch(java.rmi.RemoteException e){
            System.out.println("Servidor de Mensagens nao funciounou: " +e);
	}
  	try{new Thread(new Servidor_Agente(home,porta)).start();}
	catch(java.rmi.RemoteException e){
            System.out.println("Servidor de Agentes nao funciounou: " +e);
	}

    
    
    }
    
    
    final JFileChooser fc = new JFileChooser();
    Controlador_Tarefas co = null;
    
    public static String home;
    public static String homedir;
    public static int porta;
    
   
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenu Tarefa;
    private javax.swing.JMenuItem Criar;
    private javax.swing.JMenuItem Editar;
    private javax.swing.JMenuItem Remover;
    private javax.swing.JMenuItem Executar;
    private javax.swing.JMenuItem Cancelar;
    private javax.swing.JMenuItem Sair;
    private javax.swing.JMenu Visualizar;
    private javax.swing.JMenuItem Agentes;
    private javax.swing.JMenu Resultados;
    private javax.swing.JMenuItem Numero;
    private javax.swing.JMenuItem Grafico;
    private javax.swing.JMenu Ajuda;
    private javax.swing.JMenuItem arquivos;
    private javax.swing.JMenuItem criarTarefa;
    private javax.swing.JMenuItem executarTarefa;
    private javax.swing.JMenu Info;
    private javax.swing.JMenuItem Autor;
    // End of variables declaration//GEN-END:variables

}
