
//package agente;

import java.rmi.registry.*;
import java.rmi.server.*;

import java.rmi.*;
import java.io.*;
import java.net.*;
import java.lang.*;

public class Servidor_Agente extends UnicastRemoteObject implements IFServidor, Runnable {
	
	int porta = 0;
	String maquina = null;
	static String[] lista = null;
	private ControlaAgentes ca;
		
public Servidor_Agente(String maq, int p) throws java.rmi.RemoteException {

	porta = p;
	maquina = maq;

}

public void run() {
	
		
		iniciar(maquina,porta);
}


public void iniciar(String end, int porta){

	try{
		Naming.rebind("rmi://"+end+":"+porta+"/Servidor_Agente",this);
		}
	catch(Exception e){
		System.out.println("Excessao de URL mal construida. Abortando: "+e);
	}
	System.out.println("Me inscrevi");

/*	try{
		lista = Naming.list("rmi://"+end+":"+porta);
	}
	catch(Exception e){
		System.out.println("Deu merda: "+e);
	}
	if(lista!=null){
		System.out.println("Tamanho da lista: "+lista.length);
		int i = 0;
		while(i<lista.length){
			System.out.println("-- "+lista[i]);
			i++;
		}
	}
*/																									

}

public static void enviar(String end, int porta, AgMovel ag) 
			throws MigrarException {

	IFServidor servidor = null;
	try{servidor = (IFServidor)Naming.lookup
			("rmi://"+end+":"+porta+"/Servidor_Agente");}
	catch (Exception e){
		System.out.println 
			(ag.id+": Nao consegui migrar para "+end+" na porta :"+porta);
			throw new MigrarException(e.toString());}
	try{
		servidor.migrar(ag);
	}
	catch (RemoteException e) {
		System.err.println("Erro na serializacao" + e);
		throw new MigrarException(e.toString());
		//System.exit(1);
	}
	
	try{
		Thread.currentThread().stop();
	}
	catch(SecurityException e){
		System.err.println("Nao consegui interromper o agente");
	}
												

}

public void migrar(AgMovel ag) throws java.rmi.RemoteException {


		Thread t = new Thread(ag);
		ca = new ControlaAgentes(ag,t);
		//ag.start();
		ca.incluirAgente();
		ca.comeca();

		//ServAg filho = new ServAg(ag);
		//filho.start();


}
}


