import java.util.*;
import java.lang.*;
import java.io.*;

/** 
* Classe que controla as tarefas e trata os resultados
*/


public class ElemenTar {

//----------------------------------------------------------------------

private boolean ocupado;
private boolean acabou;
private String tarefa;
private Tarefa taref;
private Vector vetorResult;
private Vector agentes;
private int novez;
private int vez = 0;
private int primAg;
private int nAgFaltando;
private long tempoInicial;

//----------------------------------------------------------------------

public ElemenTar(){
}

//----------------------------------------------------------------------

public ElemenTar(Tarefa t, Vector v){

	ocupado = true;
	acabou = false;
	vetorResult = v;
	tarefa = t.nome;
	nAgFaltando = t.no_agentes;
	novez = t.no_vezes;
	vez =1;
	taref =t;
}

//----------------------------------------------------------------------

public boolean estaVazio(){

	if(ocupado) return false;
	else return true;

}

//----------------------------------------------------------------------

public void remover(){

	ocupado = false;
	tarefa = null;

}

//----------------------------------------------------------------------

public String pegarNome(){

	return(tarefa);
}

//----------------------------------------------------------------------

public Vector pegarVetor(){

	return(vetorResult);
}

//----------------------------------------------------------------------

public boolean acabouTarefa() {

	if(nAgFaltando == 0) return(true);
	else return(false);
}

//----------------------------------------------------------------------

public void agTerminou() {

	nAgFaltando--;
	
}

//----------------------------------------------------------------------

public int novamente() {

	nAgFaltando = taref.no_agentes;
	return(taref.intervalo);
	
}

//----------------------------------------------------------------------

public boolean maisUmaVez() {

	if(vez == novez) return(false);
	else {
		vez++;
		return(true);
		
	}
}

//----------------------------------------------------------------------

public int pegarNoVez() {

	return(vez);
	
}

//----------------------------------------------------------------------

public void primeiroAgente(int p) {

	primAg = p;
	
}

//----------------------------------------------------------------------

public int pegarPrimoAg() {

	return(primAg);
	
}

//----------------------------------------------------------------------

public void zeraVetor(Vector v) {

	vetorResult = v;
	
}

//----------------------------------------------------------------------

public void tempoInic(long t) {

	tempoInicial = t;
	
}

//----------------------------------------------------------------------

public long pegarTempoInic() {

	return(tempoInicial);
	
}

//----------------------------------------------------------------------

public int pegarMedidas() {

	return(taref.medidas);
	
}

//----------------------------------------------------------------------

public boolean pegarMedTemp(String t) {

	if(t.equals("tempoTotal"))
		if(taref.Ttempo.equals("Ttotal")) return(true);
		else return(false);
	else
		if(taref.Ptempo.equals("Tparcial")) return(true);
		else return(false);
	
}

//----------------------------------------------------------------------

}
