import java.util.*;
import java.lang.*;
import java.io.*;

/** 
* Classe que controla as tarefas e trata os resultados
*/


public class ListaTarefas {

//----------------------------------------------------------------------

private int livre;

//----------------------------------------------------------------------

/*
* Variaveis da classe
*/

private static Vector tarefas;
private static int listTam;

//----------------------------------------------------------------------

public ListaTarefas(){

	tarefas = new Vector(1);
	livre = 0;
	listTam = 0;
	

}

//----------------------------------------------------------------------

public void incluir(Tarefa tar, Vector v){

	ElemenTar elem = new ElemenTar(tar,v);
	tarefas.add(livre, elem);
	livre = proximoVazio();

}

//----------------------------------------------------------------------

public void excluir(String w){

	ElemenTar aux = new ElemenTar();
	aux = procurar(w);
	aux.remover();

}

//----------------------------------------------------------------------

public int proximoVazio(){

	livre++;
	if(livre<tarefas.size()) {
		while((!((ElemenTar)(tarefas.get(livre))).estaVazio())
									&& (livre<(tarefas.size()))) {
			livre++;
		}
	}
	return(livre);		

}

//----------------------------------------------------------------------

public ElemenTar procurar(String nome){

	int i = 0;
	boolean achou = false;
	while(!achou && (i<tarefas.size())) {
		if(!(((ElemenTar)(tarefas.get(i))).estaVazio()))
		achou = (((ElemenTar)(tarefas.get(i))).pegarNome()).equals(nome);
		if(!achou) i++;
	}
	if(i<tarefas.size()) return((ElemenTar)tarefas.get(i));
	
	else return(null);

}


}
