
import java.io.*;
import java.net.*;
import java.lang.*;

//----------------------------------------------------------------------

class Servidor_Mensagens extends Servidor implements Runnable {
		
//----------------------------------------------------------------------

public Servidor_Mensagens(String maq,int porta){

	super(porta);
}

//----------------------------------------------------------------------

public void run() {
	
	while(true){
	//	System.out.println("Servidor aguardando pedidos ....");
		Socket s1 = this.espera_Pedido();
		ServMsgObj filho = new ServMsgObj(s1);
		filho.start();
	}
		//this.fecha_Conexao();

}

//----------------------------------------------------------------------

public static Socket iniciar(String endDestino, int porta){


    InetAddress server_IP = null;
	try {
		server_IP = InetAddress.getByName(endDestino);
	}
	catch (java.net.UnknownHostException e) {
		System.err.println("Deu merda...   Host nao conhecido");
		System.exit(1);
	}
	Socket sock = null;

    try {
	    sock = new Socket(server_IP, porta);
    }
    catch (IOException e) {
	    System.err.println("Socket nao funcionou...");
   	 	System.exit(1);
    }
	return(sock);
}

//----------------------------------------------------------------------

public static void enviar(String end, int porta, Mensagem m) {

	Socket sock = iniciar(end, porta);
	try{
		ObjectOutputStream saida = new 
					ObjectOutputStream(sock.getOutputStream());
		saida.writeObject(m);
		saida.flush();
	}
	catch (IOException e) {
		System.err.println("Deu merda..."+ e);
		System.exit(1);
	}
	finally {
		try {
   			sock.close();
   			}
   		catch (IOException e) {
   			System.err.println("Nao consegui fechar o socket...");
   			System.exit(1);
   		}
   	}
}

//----------------------------------------------------------------------

public void tcp_Enviar(String end, String mensagem,int  po){

	Socket socket = iniciar(end, po);
	try {
		System.out.println("Cliente funcionando...");

		BufferedReader in = new BufferedReader(
				new InputStreamReader(socket.getInputStream()));
		PrintWriter out = new PrintWriter(new BufferedWriter(
				new OutputStreamWriter(socket.getOutputStream())),true);

		out.println(mensagem);
		out.println("END");

	}
	catch (IOException e) {
		System.err.println("Deu merda...");
		System.exit(1);
	}
	finally {
		//System.out.println("Fechando a conexao...");
		try {
   			socket.close();
   			}
   		catch (IOException e) {
   			System.err.println("Nao consegui fechar o socket...");
   			System.exit(1);
   		}
   	}
   	//System.out.println("Terminou");

}

//----------------------------------------------------------------------

}

